package com.elephant.framework.galaxy.aroad.module.zhyh.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import com.elephant.framework.galaxy.aroad.module.zhyh.entity.ZhyhLkpd;
import com.elephant.framework.galaxy.aroad.module.zhyh.service.ZhyhLkpdService;
import lombok.AllArgsConstructor;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 智慧养护_路况评定
 *
 * @author wangjian
 * @date 2019-04-22 17:45:59
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhyh/lkpd")
public class ZhyhLkpdController extends BaseController  {

  private final  ZhyhLkpdService zhyhLkpdService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhyhLkpd 智慧养护_路况评定
   * @return
   */
  @GetMapping("/page")
  public R getZhyhLkpdPage(Page page, ZhyhLkpd zhyhLkpd) {
    return  new R<>(zhyhLkpdService.page(page,Wrappers.query(zhyhLkpd)));
  }


  /**
   * 通过id查询智慧养护_路况评定
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") String id){
    return new R<>(zhyhLkpdService.getById(id));
  }

  /**
   * 新增智慧养护_路况评定批量新增
   * @param list 智慧养护_路况评定
   * @return R
   */
  @SysLog("批量新增智慧养护_路况评定")
  @PostMapping("/batchSave")
  public R batchSave(@RequestBody List<ZhyhLkpd> list){

    return new R<>(zhyhLkpdService.saveBatch(list));
  }


  /**
   * 新增智慧养护_路况评定
   * @param zhyhLkpd 智慧养护_路况评定
   * @return R
   */
  @SysLog("新增智慧养护_路况评定")
  @PostMapping("/save")
  public R save(@RequestBody ZhyhLkpd zhyhLkpd){
    return new R<>(zhyhLkpdService.save(zhyhLkpd));
  }

  /**
   * 修改智慧养护_路况评定
   * @param zhyhLkpd 智慧养护_路况评定
   * @return R
   */
  @SysLog("修改智慧养护_路况评定")
  @PutMapping
  public R updateById(@RequestBody ZhyhLkpd zhyhLkpd){
    return new R<>(zhyhLkpdService.updateById(zhyhLkpd));
  }

  /**
   * 通过id删除智慧养护_路况评定
   * @param id id
   * @return R
   */
  @SysLog("删除智慧养护_路况评定")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable String id){
    return new R<>(zhyhLkpdService.removeById(id));
  }

  /**
   * 查询起点桩号与止点桩号之间的路况评定
   * @param qdzh
   * @param zdzh
   * @return
   */
  @GetMapping("/qdzdzh")
  public R getQdZdZhanghao(@RequestParam("lxbm") String lxbm ,@RequestParam("qdzh") String qdzh, @RequestParam("zdzh") String zdzh){
    return new R<>(zhyhLkpdService.queryQdZdZhanghao(lxbm,qdzh,zdzh));
  }
}
